/*---------------------------------------------------------------------------------
 bbEdgeFlip ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 bbEdgeFlip is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 bbEdgeFlip is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#include "WMHook.h"

//---------------------------------------------------------------------------------

bool WINAPI DllMain(HINSTANCE hinst, DWORD fdwReason, LPVOID lpvReserved)
{
    if (fdwReason == DLL_PROCESS_ATTACH)
        hInstance = hinst;
    return true;
}

//---------------------------------------------------------------------------------

void SetHook()
{
    hHook = SetWindowsHookEx(WH_CALLWNDPROC, HookProc, hInstance, 0);
}

//---------------------------------------------------------------------------------

void UnsetHook()
{
    if (hHook)
        UnhookWindowsHookEx(hHook);
}

//---------------------------------------------------------------------------------

LRESULT CALLBACK HookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    if ((nCode >= 0) && lParam && (((CWPSTRUCT*)lParam)->message == WM_MOVING))
        SendMessage(FindWindow("bbEdgeFlip", NULL), FLIP_WM_MOVING, (WPARAM)((CWPSTRUCT*)lParam)->hwnd, NULL);
    return CallNextHookEx(hHook, nCode, wParam, lParam);
}

//---------------------------------------------------------------------------------
